UNIT General;
{$V-}

                            INTERFACE

USES

  Crt,
  Dos;

CONST

  HexTekens : string[16] = '0123456789ABCDEF';
  WoordTekens = ['a'..'z', 'A'..'Z', '0'..'9', '_', '[', ']'];
  CijferTekens = ['0'..'9'];
  SpatieTekens = [' ',#9];
  TweedeMacht : array[0..7] of byte = (1,2,4,8,16,32,64,128);
  PrintScreen : boolean = false;
  kbPrintScreen = $FFFF;

TYPE

  TParameters = object
                  aantal : byte;
                  procedure init;
                  function ZoekGetalSwitch(tekst : string; default : real) : real;
                  function Help : boolean;
                  function ZoekTekstSwitch(tekst : string; default : string) : string;
                  function ZoekSwitch(tekst : string) : boolean;
                  procedure verwijderswitches;
                  function haal(nummer : byte) : string;
                private
                  uitgesloten : array[1..10] of boolean;
                  function isSwitch(str : string) : boolean;
                end;

FUNCTION  AbsVerschil(Getal1,getal2 : word) : word;
PROCEDURE Atlantis(Instellen : boolean);
PROCEDURE Beep;
FUNCTION  Berekenbyte(str : string; teken0, teken1 : char) : byte;
FUNCTION  Byte2Hex(getal : byte) : string;
FUNCTION  CursorPos : word;
FUNCTION  CursorVisible : boolean;
FUNCTION  DestilleerDir(pad : pathstr) : dirstr;
PROCEDURE DonePrintScreen;
FUNCTION  DriveValid(Drive: Char): Boolean;
FUNCTION  Equal(var rec1,rec2; count : word) : boolean;
FUNCTION  ExeName(Normalname : NameStr) : PathStr;
FUNCTION  ExtractName(APath : pathstr) : NameStr;
FUNCTION  ExtractInt(var Astr : string; DefaultValue : integer) : integer;
FUNCTION  FileExists(Filename : Pathstr) : boolean;
FUNCTION  GetCurDir: DirStr;
FUNCTION  Hex2Byte(str : string) : byte;
FUNCTION  Hex2Nibble(ch : char) : byte;
FUNCTION  HiNibble(getal : byte) : byte;
PROCEDURE InitPrintScreen;
FUNCTION  Int2Str(L : LongInt) : string;
PROCEDURE LedigKlavierBuffer;
FUNCTION  LeesBareLongint(waarde : longint) : string;
FUNCTION  LoNibble(getal : byte) : byte;
FUNCTION  Longint2Ptr(ALongint : longint) : pointer;
FUNCTION  Macht(X,Y : real) : real;
FUNCTION  PathValid(var Path: PathStr): Boolean;
PROCEDURE PressAnyKey;
FUNCTION  Ptr2Longint(Apointer : pointer) : longint;
PROCEDURE ReplaceExt(var APath : PathStr; NewExt : ExtStr);
FUNCTION  Splitsbyte(waarde : byte; teken0, teken1 : char) : string;
FUNCTION  Str2Int(str : string) : integer;
FUNCTION  Strip(str : string) : string;
FUNCTION  StripBegin(str : string) : string;
FUNCTION  StripEinde(str : string) : string;
FUNCTION  StripLine(str : string) : string;
PROCEDURE SwapWord(var getal1, getal2 : word);
FUNCTION  TijdNu : Longint;
FUNCTION  UpperCase(str : string) : string;
FUNCTION  ValidFileName(var FileName: PathStr): Boolean;
FUNCTION  VraagInteger(tekst : String; van, tot : Integer) : Integer;
FUNCTION  VraagJaNee(DeVraag : string; voorkeur : boolean) : Boolean;
FUNCTION  Word2Hex(getal : word) : string;
FUNCTION  XSqrt(Getal: real) : real;

VAR

  Parameters : TParameters;


                            IMPLEMENTATION

USES

  Drivers;

VAR

  ExitSave : pointer;
  SavePrtScr : pointer;


TYPE

  PtrRec = record
    Ofs : word;
    Seg : Word;
    end;

PROCEDURE PrintScreenPressedRoutine; interrupt;

  begin

    PrintScreen:=true;

  end;


PROCEDURE InitPrintScreen;

  begin

    GetIntvec($05,SavePrtScr);
    SetIntVec($05,@PrintScreenPressedRoutine);

  end;


PROCEDURE DonePrintScreen;

  begin

    SetIntVec($05,SavePrtScr);

  end;


FUNCTION ExtractInt(var Astr : string; DefaultValue : integer) : integer;

  var

   pos : integer;
   waarde : integer;
   tempstr : string;

  begin

    ExtractInt:=DefaultValue;
    if length(astr)>0 then
      begin
      pos:=1;
      while (pos<=length(astr)) and not (astr[pos] in CijferTekens) do pos:=pos+1;
      astr:=copy(astr,pos,length(astr)-pos+1);
      if length(astr)>0 then
        begin
        val(astr,waarde,pos);
        if pos=0
          then
            begin
            astr:='';
            Extractint:=waarde;
            exit;
            end
          else
            begin
            tempstr:=copy(astr,1,pos-1);
            astr:=copy(astr,pos,length(astr)-pos+1);
            val(tempstr,waarde,pos);
            if pos<>0 then runerror(255);
            Extractint:=waarde;
            end;
        end;
      end;

  end;


FUNCTION Str2Int(str : string) : integer;

  const

    waarde : integer = 0;

  var

    code : integer;

  begin

    Val(str,waarde,code);
    if code>1 then
    Val(copy(str,1,code-1),waarde,code);
    Str2Int:=waarde;

  end;


PROCEDURE Beep;

  begin

    Sound(200);
    Delay(200);
    NoSound;

  end;


FUNCTION FileExists;

  var

    test : text;

  begin

    {$I-}
    assign(test,filename);
    reset(test);
    if IOResult<>0 then FileExists:=false else
      begin
      close(test);
      FileExists:=true;
      end;
    {$I+}

  end;


FUNCTION Word2Hex;

  begin

    Word2Hex:=Byte2hex(hi(getal))+byte2Hex(lo(getal));

  end;


FUNCTION Byte2Hex;

  begin

    Byte2hex:=HexTekens[HiNibble(getal)+1]+HexTekens[LoNibble(getal)+1];

  end;


FUNCTION HiNibble;

  begin

    getal:=getal and $F0;
    Hinibble:=getal shr 4;

  end;


FUNCTION LoNibble;

  begin

    LoNibble:=getal and $0F;

  end;


FUNCTION uppercase(str : string) : string;

  var

    teller : byte;

  begin

    for teller:=1 to length(str) do str[teller]:=upcase(str[teller]);
    uppercase:=str;

  end;


FUNCTION VraagJaNee;

  var

    X, Y : byte;
    keuze : boolean;
    stop : boolean;

  begin

    Write(DeVraag);
    X:=whereX;
    Y:=whereY;
    keuze:=voorkeur;
    stop:=false;
    repeat
      GotoXy(X,Y);
      if keuze then write('Ja ') else write('Nee');
      case readkey of
        'J', 'j', 'Y', 'y' : keuze:=true;
        'N', 'n' : keuze:=false;
        #27 : begin
                 keuze:=voorkeur;
                 stop:=true;
                 end;
        #13 : stop:=true;
        #0 : begin
              if readkey='' then ;
              keuze:=not keuze;
              end;
        else keuze:=not keuze;
        end;
    until stop;
    GotoXy(X,Y);
    if keuze then writeln('Ja ') else writeln('Nee');
    Vraagjanee:=keuze;

  end;


PROCEDURE Atlantis;

  var

    regs : registers;

  begin

    with regs do
      begin
      AH:=$0F;
      intr($10,regs);
      end;
    if regs.AL=7 then
      begin
      if instellen then port[$3B8]:=10 else port[$3B8]:=42;
      end
      else
      begin
      with regs do
        begin
        AX:=$1003;
        BL:=ord(not(instellen));
        end;
      intr($10,regs);
      end;

  end;

PROCEDURE LedigKlavierBuffer;

  begin

    while keypressed do if readkey='' then ;

  end;


PROCEDURE PressAnyKey;

  begin

    LedigKlavierBuffer;
    Repeat until keypressed;
    LedigKlavierBuffer;

  end;


function DriveValid(Drive: Char): Boolean; assembler;

  asm
	MOV	DL,Drive
        MOV	AH,36H
        SUB	DL,'A'-1
        INT	21H
        INC	AX
        JE	@@2
  @@1:	MOV	AL,1
  @@2:

  end;


function PathValid(var Path: PathStr): Boolean;

  var

    ExpPath: PathStr;
    F: File;
    SR: SearchRec;

  begin

    ExpPath := FExpand(Path);
    if Length(ExpPath) <= 3 then PathValid := DriveValid(ExpPath[1])
    else
      begin
      if ExpPath[Length(ExpPath)] = '\' then Dec(ExpPath[0]);
      FindFirst(ExpPath, Directory, SR);
      PathValid := (DosError = 0) and (SR.Attr and Directory <> 0);
      end;
  end;


function ValidFileName(var FileName: PathStr): Boolean;

  const

    IllegalChars = ';,=+<>|"[] \';

  var

    Dir: DirStr;
    Name: NameStr;
    Ext: ExtStr;

{Geeft true terug indien S1 een teken bevat uit S2}
function Contains(S1, S2: String): Boolean; near; assembler;

  asm
	PUSH	DS
        CLD
        LDS	SI,S1
        LES	DI,S2
        MOV	DX,DI
        XOR	AH,AH
        LODSB
        MOV	BX,AX
        OR      BX,BX
        JZ      @@2
        MOV	AL,ES:[DI]
        XCHG	AX,CX
  @@1:	PUSH	CX
	MOV	DI,DX
	LODSB
        REPNE	SCASB
        POP	CX
        JE	@@3
	DEC	BX
        JNZ	@@1
  @@2:	XOR	AL,AL
	JMP	@@4
  @@3:	MOV	AL,1
  @@4:	POP	DS

  end;


  begin

    ValidFileName := True;
    FSplit(FileName, Dir, Name, Ext);
    if not ((Dir = '') or PathValid(Dir)) or Contains(Name, IllegalChars) or
    Contains(Dir, IllegalChars) then ValidFileName := False;

  end;


function GetCurDir: DirStr;

  var

    CurDir: DirStr;

  begin

    GetDir(0, CurDir);
    if Length(CurDir) > 3 then
      begin
      Inc(CurDir[0]);
      CurDir[Length(CurDir)] := '\';
      end;
    GetCurDir := CurDir;

  end;


FUNCTION VraagInteger(tekst : String; van, tot : Integer) : Integer;

  var

    fout : Integer;
    invoerString : String;
    waarde : Integer;
    gadoor : Boolean;

  BEGIN

    REPEAT
      GaDoor:=true;
      Write(tekst);
      Readln(invoerString);
      val(invoerString,waarde,fout);
      IF fout<>0 THEN
        BEGIN
        Writeln('Je doet iets fout !');
        Gadoor:=false;
        waarde:=van;
        END;
      IF not((waarde>=van) and (waarde<=tot)) THEN
        BEGIN
        Writeln('Het getal moet tussen ',van,' en ',tot,' liggen !');
        Gadoor:=false;
        END;
    UNTIL gadoor;
    vraaginteger:=waarde;

  END;


FUNCTION DestilleerDir(pad : pathstr) : dirstr;

  var

    N : NameStr;
    E : ExtStr;
    D : DirStr;

  begin

    if (Pos('*',pad)<>0) or (Pos('?',pad)<>0) then
       begin
       Fsplit(Pad,D,N,E);
       DestilleerDir:=D;
       end else destilleerdir:=pad;

  end;


procedure SwapWord(var getal1, getal2 : word);

  var

    temp : word;

  begin

    temp:=getal2;
    getal2:=getal1;
    getal1:=temp;

  end;

FUNCTION Strip(str : string) : string;

  var

    teller : byte;

  BEGIN

    while not(str[1] in woordtekens) AND (length(str)>0) do delete(str,1,1);
    while not(str[length(str)] in woordtekens) AND (length(str)>0) do delete(str,length(str),1);
    str:=uppercase(str);
    Strip:=str;

  END;


FUNCTION StripBEGIN(str : string) : string;

  BEGIN

    while (length(str)<>0) AND (str[1] in SpatieTekens) do delete(str,1,1);
    StripBegin:=str;

  END;


FUNCTION StripEinde(str : string) : string;

  BEGIN

    while (length(str)<>0) AND (str[length(str)] in Spatietekens) do delete(str,length(str),1);
    stripeinde:=str;

  END;


FUNCTION StripLine(str : string) : string;

  BEGIN

    Stripline:=StripBegin(StripEinde(str));

  END;


FUNCTION Splitsbyte(waarde : byte; teken0, teken1 : char) : string;

  VAR

    t : string;
    w : byte;

  BEGIN

    w := 128;
    t:='';
    REPEAT
     IF waarde AND w > 0 THEN t:=t+teken1 ELSE t:=t+teken0;
     w := w shr 1;
    UNTIL w=0;
    splitsbyte:=t;

  END;


FUNCTION berekenbyte(str : string; teken0, teken1 : char) : byte;

  var

    teller : byte;
    waarde : byte;

  BEGIN

    waarde:=0;
    for teller:=1 to 8 do IF str[teller]=teken1 THEN waarde:=waarde+tweedemacht[8-teller];
    berekenbyte:=waarde;

  END;

function tijdnu;

  var

    uur, minuut, second , rommel : word;

  begin

    GetTime(Uur,minuut, second, rommel);
    tijdnu:=second+minuut*60+uur*3600;

  end;


function Macht(X, Y: Real): Real;

  begin

    Macht := Exp(Y * Ln(X));

  end;


function XSqrt;

  begin

    if Getal<0
      then XSqrt:=-sqrt(-getal)
      else XSqrt:=sqrt(getal);

  end;

function LeesBareLongint;

  var

    S : string;
    teller : byte;
    positie : byte;

  begin

    str(Waarde,S);
    teller:=1;
    for positie:=length(S) downto 1 do
      begin
      if (teller=3) and (positie<>1) then
         begin
         insert('''',S,positie);
         teller:=0;
         end;
      teller:=teller+1;
      end;
    LeesBareLongint:=S;

  end;


function AbsVerschil;

  begin

    if getal1>getal2
      then absverschil:=getal1-getal2
      else absverschil:=getal2-getal1;

  end;


function Int2Str(L : LongInt) : string;

  var

    S : string;

  begin

    Str(L, S);
    Int2Str := S;

  end; 


FUNCTION Longint2Ptr;

  var

    NewPtr : Pointer;

  begin

    PtrRec(NewPtr).Seg:=ALongint div 16;
    PtrRec(NewPtr).ofs:=ALongint mod 16;
    Longint2Ptr:=NewPtr;

  end;


FUNCTION Hex2Nibble;

  begin

    if (ch>='0') and (ch<='9')
      then Hex2Nibble:=ord(ch)-48
      else
        begin
        ch:=upcase(ch);
        if (ch>='A') and (ch<='F')
          then Hex2Nibble:=ord(ch)-55
          else runerror(255);
       end;

  end;


FUNCTION Hex2Byte;

  begin

    if length(str)=1
      then Hex2Byte:=Hex2Nibble(str[1])
      else Hex2Byte:=Hex2Nibble(str[1])*16+Hex2Nibble(str[2]);

  end;


FUNCTION Ptr2Longint;

  begin

    Ptr2Longint:=PtrRec(APointer).seg*16
    +PtrRec(Apointer).ofs;

  end;


PROCEDURE GeneralExit; far;

{$IfDef Debugging}

  var

    Bestand : text;
    line : string;

{$Endif}
  begin

    DonePrintScreen;
    exitproc:=exitsave;
    if erroraddr<>nil then
      begin
      writeln('Internal error ',exitcode,' at ',
      Word2Hex(ptrrec(erroraddr).seg),':',Word2Hex(ptrrec(erroraddr).ofs));
{$IfDef Debugging}
{$I-}
      assign(bestand,'D:\runerror.pas');
      reset(bestand);
      line:='';
      while (Str2int(line)<>exitcode) and not(eof(bestand)) do readln(bestand,line);
      if eof(bestand)
        then Writeln(' ',exitcode,'  Unknown error')
        else Writeln(line);
      close(bestand);
{$I+}
{$Else}
      writeln('Please report me !!!');
{$EndIf}
      erroraddr:=nil;
      end;

  end;

PROCEDURE TParameters.Init;

  var

    teller : byte;

  begin

    for teller:=1 to 10 do uitgesloten[teller]:=false;
    aantal:=paramcount;

  end;


FUNCTION TParameters.ZoekGetalSwitch(tekst : string;default : real) : real;

  var

    str : string;
    waarde : real;
    error : integer;

  begin

    str:=ZoekTekstSwitch(tekst,'dummy...dummy...dummy');
    val(str,waarde,error);
    if error<>0 then waarde:=default;
    ZoekGetalSwitch:=waarde;

  end;


FUNCTION TParameters.Help : boolean;

  begin

    Help:=Zoekswitch('?') or zoekswitch('/?');

  end;


FUNCTION TParameters.ZoekTekstSwitch(tekst : string; default : string) : string;

  var

   teller : byte;
   lengte : byte;

  begin

    tekst:=uppercase(tekst);
    lengte:=length(tekst);
    for teller:=1 to paramcount do
      begin
      if (uppercase(copy(paramstr(teller),1,lengte))=tekst)
      and not(uitgesloten[teller]) then
        begin
        tekst:=paramstr(teller);
        if length(tekst)>lengte then delete(tekst,1,lengte) else tekst:=default;
        ZoekTekstSwitch:=tekst;
        exit;
        end;
      end;
    ZoekTekstSwitch:=default;

  end;


FUNCTION TParameters.ZoekSwitch (tekst : string) : boolean;

  var

    teller : byte;
    lengte : byte;

  begin

    tekst:=uppercase(tekst);
    lengte:=length(tekst);
    for teller:=1 to paramcount do
      begin
      if (uppercase(copy(paramstr(teller),1,lengte))=tekst)
      and not(uitgesloten[teller]) then
        begin
        ZoekSwitch:=true;
        exit;
        end;
      end;
    ZoekSwitch:=false;

  end;


PROCEDURE TPArameters.VerwijderSwitches;

  var

    teller : byte;

  begin

    for teller:=1 to paramcount do
      begin
      if isswitch(paramstr(teller)) and not(uitgesloten[teller]) then
         begin
         uitgesloten[teller]:=true;
         aantal:=aantal-1;
         end;
      end;

  end;


FUNCTION TParameters.Haal(nummer : byte) : string;

  var

    nummerdiemeeteld : byte;
    teller           : byte;

  begin

    nummerdiemeeteld:=0;
    for teller:=1 to paramcount do
      begin
      if not(uitgesloten[teller]) then nummerdiemeeteld:=nummerdiemeeteld+1;
      if nummerdiemeeteld=nummer then
         begin
         haal:=paramstr(teller);
         exit;
         end;
      end;

  end;


function TParameters.isswitch(str : string) : boolean;

  begin

    if copy(str,1,1)='/' then isswitch:=true else isswitch:=false

  end;


FUNCTION ExeName(NormalName : NameStr) : PathStr;

  var

    EN : pathstr;

  begin

    if Lo(DosVersion) >= 3 then EN:=ParamStr(0)
      else
        begin
        EN := FSearch(NormalName, GetEnv('PATH'));
        if EN = '' then
          begin
          PrintStr(NormalName + ' could not be found.'#13#10);
          halt;
          end;
        end;
    ExeName:=EN;

  end;


FUNCTION ExtractName(APath : pathstr) : NameStr;

  var

    AName : namestr;

  begin

    FSplit(APath,APath,AName,APath);
    ExtractName:=AName;

  end;


PROCEDURE ReplaceExt(var APath : PathStr; NewExt : ExtStr);

  var

    ADir : DirStr;
    AName : NameStr;

  begin

    FSplit(APath,Adir,Aname,APath);
    APath:=ADir+Aname+NewExt;

  end;


FUNCTION Equal; assembler;

  asm

    MOV  DX,DS
    LDS  SI,rec1
    LES  DI,rec2
    MOV  CX,count
    CLD
    CMP  SI,DI
    JNB  @@2
    ADD  SI,CX
    ADD  DI,CX
    DEC  SI
    DEC  DI
    STD
  @@2:
    REPE CMPSB
    MOV  AL,0
    JNZ  @@3
    INC  AL
  @@3:
    MOV  [bp-1],al
    MOV  DS,DX

  end;


FUNCTION CursorVisible : boolean;

  var

    LastY : byte;
    BeginY : byte;

  begin

    asm
    MOV ah,$03;
    MOV bh,$00;
    INT $10;
    MOV LastY,CL;
    MOV BeginY,CH;
    end;
    If LastY<BeginY
      then Cursorvisible:=false
      else Cursorvisible:=true;

  end;


FUNCTION CursorPos : word; assembler;

  asm

    MOV ah,$03;
    MOV bh,$00;
    INT $10;
    MOV AX,DX;

  end;


begin

  Parameters.Init;
  ExitSave:=ExitProc;
  ExitProc:=@GeneralExit;
  InitPrintScreen;

END.
